with Constants;

with New_Area_Type_Package;
use  New_Area_Type_Package;

with Generic_Data_Structures.Queue;

package body Area_Queue_Package is

   package Queue is new Generic_Data_Structures.Queue( New_Area_Type );
   use Queue;

   AQueue : Queue_Type_Access := new Queue_Type;
   Remaining_Tasks : Integer := Constants.Number_Of_Tasks;

   protected body Area_Queue is
    
      entry Put( Area  : in out New_Area_Type ) when (Done'Count = 0 ) is --( Get'Count = 0 ) and then
                                                                          --( Length( AQueue ) /= 0 ) is

      begin
         Put( Item  => Area,
              Queue => AQueue );
      end Put;


      entry Get( Area : in out New_Area_Type ) when ( Done'Count = 0 ) and then
                                                    ( Length( AQueue ) > 0 ) is --and then 
                                                    --( Put'Count = 0 ) is
      begin
         Area := Get( Queue => AQueue );
      end Get;

      entry Done( Done : out Boolean ) when True is
      begin
         Done := ( Get'Count = Constants.Number_Of_Tasks ) and then
                 ( Length( AQueue ) = 0 ) ;
      end Done;

   end Area_Queue;
end Area_Queue_Package;
