-- Callback for simple motif program
-- Chris Morgan 3/9/95
with X.Xlib;
with X.Strings;
with Xt.Intrinsic;
with Interfaces.C;
with Motif.Xm;
with Stdarg;
package Callbacks_Package is

   type Simple_Colour_Name_Type is (None,
				    DarkSlateBlue,
				    MediumSlateBlue,
				    LightSlateBlue,
				    DarkSeaGreen,
				    MediumSeaGreen,
                                    LightSeaGreen,
                                    DarkOrchid1,
                                    DarkOrchid2,
                                    DarkOrchid3,
      IndianRed1, IndianRed2, IndianRed3, HotPink1, Red, White, Black);


The_Gc       : X.Xlib.gc;
Gcvalues     : X.Xlib.Xgcvalues;
My_Window    : Xt.Intrinsic.Widget;
Button1      : Xt.Intrinsic.Widget;
Button2      : Xt.Intrinsic.Widget;
Button3      : Xt.Intrinsic.Widget;
Drawing_Area : Xt.Intrinsic.Widget;
Form         : Xt.Intrinsic.Widget;
Main_Window  : Xt.Intrinsic.Widget;
Label_Widget : Xt.Intrinsic.Widget;
app          : aliased Xt.Intrinsic.XtAppContext;
label        : Motif.Xm.XmString;
Nulst        : constant X.Strings.Const_Charp := null;
valuemask    : Interfaces.C.unsigned_long := 0; 
values       : aliased X.Xlib.XGCValues;
    
    function "&" is new Stdarg.Concat(X.Strings.Const_Charp);
    function "&" is new Stdarg.Concat(Xt.Intrinsic.Dimension);
    function "&" is new Stdarg.Concat(Motif.Xm.XmString);
    function "&" is new Stdarg.Concat(Motif.Xm.Enum_Anonymous21_t);
    function "&" is new Stdarg.Concat(Xt.Intrinsic.Widget);

   procedure ExposureCB
     (W		  : Xt.Intrinsic.Widget;
      Client_Data : Xt.Intrinsic.XtPointer;
      cbs	  : Xt.Intrinsic.XtPointer);
   pragma Convention(C,Exposurecb);

   procedure ResizeCB
     (W		  : Xt.Intrinsic.Widget;
      Client_Data : Xt.Intrinsic.XtPointer;
      cbs	  : Xt.Intrinsic.XtPointer);
   pragma Convention(C,Resizecb);

   procedure InputCB
     (W		  : Xt.Intrinsic.Widget;
      Client_Data : Xt.Intrinsic.XtPointer;
      cbs	  : Xt.Intrinsic.XtPointer);
   pragma Convention(C,Inputcb);

   -- Program specific callbacks
   procedure Redraw  
     (W		  : Xt.Intrinsic.Widget;
      Client_Data : Xt.Intrinsic.XtPointer;
      cbs	  : Xt.Intrinsic.XtPointer);
   pragma Convention(C,Redraw);

   procedure Reset 
     (W		  : Xt.Intrinsic.Widget;
      Client_Data : Xt.Intrinsic.XtPointer;
      cbs	  : Xt.Intrinsic.XtPointer);
   pragma Convention(C,Reset);

   procedure Go_away
     (W		  : Xt.Intrinsic.Widget;
      Client_Data : Xt.Intrinsic.XtPointer;
      cbs	  : Xt.Intrinsic.XtPointer);
   pragma Convention(C,Go_Away);

   procedure Loc_Set_Colour
     (W	  : in Xt.Intrinsic.Widget;
      Col : in Simple_Colour_Name_Type;
      Fg  : in Boolean		       := true);


end;


