with X;
use  X;

with Xt.Intrinsic;
use  Xt.Intrinsic;

with Interfaces.C;
use  Interfaces.C;

with Text_Io;

with Output_Queue_Package;
use  Output_Queue_Package;

with Output_Area_Type_Package;
use  Output_Area_Type_Package;

with Area_Type_Package;
use  Area_Type_Package;

with Constants;
use  Constants;

with Callbacks_Package;
use  Callbacks_Package;

with Output_Queues;
use  Output_Queues;

package body Display_Task_Package is

   Wt   : Xt.Intrinsic.Widget;
   Last_Colour : Simple_Colour_Name_Type := Callbacks_Package.None;

   Queue : Queue_Type_Access := new Queue_Type;

   procedure Output_Area( Area : in Output_Area_Type ) is

      Colour : Simple_Colour_Name_Type := Callbacks_Package.None;

      Bot_Left_X  : Integer := Integer( ( Area.Area.Bottom_Left.Re - Initial_Area.Bottom_Left.Re ) / X_Delta );
      Bot_Left_Y  : Integer := Integer( ( Area.Area.Bottom_Left.Im - Initial_Area.Bottom_Left.Im ) / Y_Delta );
      Top_Right_X : Integer := Integer( ( Area.Area.Top_Right.Re - Initial_Area.Bottom_Left.Re ) / X_Delta );
      Top_Right_Y : Integer := Integer( ( Area.Area.Top_Right.Im - Initial_Area.Bottom_Left.Im ) / Y_Delta );
      Width       : Integer := Top_Right_X - Bot_Left_X + 1;
      Height      : Integer := Top_Right_Y - Bot_Left_Y + 1;

   begin

      -- yukky I know, but I can't be bothered to think about it...
      case Area.Heat is
         when 0 =>
            Colour := darkslateBlue;
         when 1 =>
            Colour := Mediumslateblue;
         when 2 =>
            Colour := LightSlateBlue;
         when 3 =>
            Colour := DarkSeaGreen;
         when 4 =>
            Colour := MediumSeaGreen;
         when 5 =>
            Colour := LightSeaGreen;
         when 6 =>
            Colour := DarkOrchid1;
         when 7 =>
            Colour := DarkOrchid2;
         when 8 =>
            Colour := DarkOrchid3;
         when 9 =>
            Colour := IndianRed1;
         when 10 =>
            Colour := IndianRed2;
         when 11 =>
            Colour := IndianRed3;
         when 12 =>
            Colour := Black ;
         when 13 =>
            Colour := Red;
         when 14 =>
            Colour := MediumSlateBlue;
         when others =>
            Colour := Black ;
         end case;

--      if not ( Colour = Black ) then

         if Colour /= Last_Colour then
            Loc_Set_Colour( W   => Wt,
                            Col => Colour,
                            Fg  => True ); 
         end if;

         X.Xlib.Xfillrectangle(Display => Xt.Intrinsic.Xtdisplay(Drawing_Area),
	   		       D => X.Drawable(Xt.Intrinsic.Xtwindow(Drawing_Area)),
			       Gc => The_Gc,
			       Xx => Interfaces.C.Int( Bot_Left_X ),
			       Y =>  Interfaces.C.Int( Bot_Left_Y ),
			       Width => Interfaces.C.Unsigned( Width ),
			       Height => Interfaces.C.Unsigned( Height ) );
--      end if;

   end Output_Area;


   procedure Display_Task ( W : in Xt.Intrinsic.Widget )is
      Done : Boolean := False;
      Count : Integer := 0;
   begin

         Wt := W;

      while not Done loop

--Text_Io.Put_Line( "display task package 1" ); Text_Io.Flush;

	 Output_Queue.Toggle_Queues( Queue, Done );

         if Done then
            Text_Io.Put_Line( "Maths Done" ); Text_Io.Flush;
         end if;

         while Length( Queue ) > 0 loop
            Output_Area( Get( Queue ) );
         end loop;

      end loop;

      X.Xlib.Xsync( Display => Xt.Intrinsic.Xtdisplay(Drawing_Area),
                    Discard => 0 );

   end Display_Task;

end Display_Task_Package;
