with text_io; use text_io;
with Unchecked_Deallocation;

package body Generic_Data_Structures.Queue is
   
   procedure Free is new Unchecked_Deallocation( Object => Element_Type,
                                                 Name   => Element_Ptr_Type );

   procedure Put    ( Item  : Item_Type;
                      Queue : access Queue_Type ) is
      Item_Pointer : Item_Type_Pointer
                   := new Item_Type'( Item );
      Old_Head : Element_Ptr_Type := Queue.Head;
   begin
      if Queue.Length = 0
      then
         Queue.Tail := new Element_Type'( Item_Pointer, null );
         Queue.Head := Queue.Tail;
      else
         Queue.Head    := new Element_Type'( Item_Pointer, null );
         Old_Head.Next := Queue.Head;
      end if;
      Queue.Length := Queue.Length + 1;
   end Put;

   function  Get    ( Queue : access Queue_Type ) return Item_Type is
      Tail     : Element_Ptr_Type;
      Item_Ptr : Item_Type_Pointer;
   begin
      if Queue.Length > 0
      then
         Tail         := Queue.Tail;
         Item_Ptr     := Tail.Item;
         Queue.Tail   := Tail.Next;
         Queue.Length := Queue.Length - 1;
         Free( Tail );
         return Item_Ptr.all;
      else
         raise Empty;
      end if;
   end Get;

   procedure Swap( Source_Queue      : access Queue_Type;
                   Destination_Queue : access Queue_Type ) is
      Temp : Queue_Type_Access := new Queue_Type;
   begin
      Temp.all              := Source_Queue.all;
      Source_Queue.all      := Destination_Queue.all;
      Destination_Queue.all := Temp.all;
   end Swap;

   procedure Append ( Source_Queue      : in out Queue_Type_Access;
                      Destination_Queue : in out Queue_Type_Access ) is
   begin
      --temporary crappy implementation
      --though possibly logically appropriate!
--      while Source_Queue.Length > 0 loop
--        Put( Get( Source_Queue ), Destination_Queue );
--      end loop;
      
-- The implementation I really wanted to use is below:
-- It doesn't work, and while I'm still working on it, I may be STUCK!!!!!
-- ( It does work in a simple single threaded test program! :(
-- Something to do with the depth rules I think.

--Text_Io.Put_Line( "Generic Queue: A" );  Text_Io.Flush;
--Text_Io.Put_Line( "Source:      " & Long_Integer'Image( Long_Integer( Source_Queue.Length ) ) );
--Text_Io.Put_Line( "Destination: " & Long_Integer'Image( Long_Integer( Destination_Queue.Length ) ) );
--Text_Io.Flush;
      if Destination_Queue.Length = 0 then
--   Destination_Queue := Source_Queue;
         Swap( Destination_Queue, Source_Queue );
      else
         Destination_Queue.Head.Next := Source_Queue.Tail;
--Text_Io.Put_Line( "Generic Queue: B" );  Text_Io.Flush;
         Destination_Queue.Head      := Source_Queue.Head;
--Text_Io.Put_Line( "Generic Queue: C" );  Text_Io.Flush;
         Destination_Queue.Length    := Destination_Queue.Length + Source_Queue.Length;

--Text_Io.Put_Line( "Generic Queue: D" );  Text_Io.Flush;
         Source_Queue.Tail := null;
--Text_Io.Put_Line( "Generic Queue: E" );  Text_Io.Flush;
         Source_Queue.Head := null;
--Text_Io.Put_Line( "Generic Queue: F" );  Text_Io.Flush;
         Source_Queue.Length := 0;

--Text_Io.Put_Line( "Generic Queue: G" );  Text_Io.Flush;
      end if;
   
   end Append;

   -- I really don't like this either!
   procedure Flush  ( Queue : access Queue_Type ) is
   begin
      while Queue.Length > 0 loop
         declare
            Item : Item_Type := Get( Queue );
         begin
            null;
         end;
      end loop;
   end Flush;

   function  Length ( Queue : access Queue_Type ) return Long_Integer is
   begin
      return Queue.Length;
   end Length;

end Generic_Data_Structures.Queue;







