generic
   type Item_Type(<>) is private;
package Generic_Data_Structures.Queue is
   type Queue_Type is limited private;
   type Queue_Type_Access is access Queue_Type;
   procedure Put    ( Item              : Item_Type;
                      Queue             : access Queue_Type );
   procedure Append ( Source_Queue      : in out Queue_Type_Access;
                      Destination_Queue : in out Queue_Type_Access );
   procedure Swap   ( Source_Queue      : access Queue_Type;
                      Destination_Queue : access Queue_Type );
   function  Get    ( Queue             : access Queue_Type ) return Item_Type;
   procedure Flush  ( Queue             : access Queue_Type );
   function  Length ( Queue             : access Queue_Type ) return Long_Integer;
private
   type Item_Type_Pointer is access Item_Type;
   type Element_Type;
   type Element_Ptr_Type is access Element_Type;
   type Element_Type is
      record
         Item : Item_Type_Pointer := null;
         Next : Element_Ptr_Type  := null;
      end record;
   type Queue_Type is
      record
          Head   : Element_Ptr_Type  := null; 
          Tail   : Element_Ptr_Type  := null;
          Length : Long_Integer := 0;
       end record;
end Generic_Data_Structures.Queue;







