with Text_Io;
with Ada.Exceptions;
use  Ada.Exceptions;

with Area_Type_Package;
use  Area_Type_Package;

with Area_Queue_Package;
use  Area_Queue_Package;

with Mandel_Task_Package;
with Complex_Type_Package;

with Area_Type_List_Package;
use  Area_Type_List_Package;

with New_Area_Type_Package;
use  New_Area_Type_Package;

with Output_Queue_Package;
use  Output_Queue_Package;

with Display_Task_Package;
use  Display_Task_Package;

with Output_Queues;

with Constants;
use  Constants;

with Queue_Array_Package;

pragma Elaborate( Area_Queue_Package );
pragma Elaborate( Output_Queue_Package );
pragma Elaborate( Display_Task_Package );
pragma Elaborate( Queue_Array_Package );

package body Mandel_Control_Package is

   procedure Initialise_Queue is
      Area : New_Area_Type := ( Constants.Screen_Size_X, Constants.Screen_Size_Y, 0, 0,
                                False, False, False, False, -1, -1, -1, -1 );
   begin
       Area_Queue_Package.Area_Queue.Put( Area => Area );
   end Initialise_Queue;


   procedure Generate_Plot( W : in Xt.Intrinsic.Widget ) is

      type Task_Array_Type is array (Integer range 1..Number_Of_Tasks) of Mandel_Task_Package.Mandel_Task;
      Task_Array : Task_Array_Type;
--      Mandel_Task_1  : Mandel_Task_Package.Mandel_Task;
--      Queue_1        : Output_Queues.Queue_Type_Access := new Output_Queues.Queue_Type;
--      Mandel_Task_2  : Mandel_Task_Package.Mandel_Task;
--      Queue_2        : Output_Queues.Queue_Type_Access := new Output_Queues.Queue_Type;
--      Mandel_Task_3  : Mandel_Task_Package.Mandel_Task;
--      Mandel_Task_4  : Mandel_Task_Package.Mandel_Task;
--      Mandel_Task_5  : Mandel_Task_Package.Mandel_Task;
--      Mandel_Task_6  : Mandel_Task_Package.Mandel_Task;
--      Mandel_Task_7  : Mandel_Task_Package.Mandel_Task;
--      Mandel_Task_8  : Mandel_Task_Package.Mandel_Task;
--      Mandel_Task_9  : Mandel_Task_Package.Mandel_Task;
--      Mandel_Task_10 : Mandel_Task_Package.Mandel_Task;
--      Mandel_Task_11 : Mandel_Task_Package.Mandel_Task;
--      Mandel_Task_12 : Mandel_Task_Package.Mandel_Task;
--      Mandel_Task_13 : Mandel_Task_Package.Mandel_Task;
--      Mandel_Task_14 : Mandel_Task_Package.Mandel_Task;
--      Mandel_Task_15 : Mandel_Task_Package.Mandel_Task;
--      Mandel_Task_16 : Mandel_Task_Package.Mandel_Task;

--      Area_Queue_Waiting   : Boolean := False;
--      Output_Queue_Waiting : Boolean := False;

   begin

      Text_Io.Put_Line( "Hello 1" ); Text_Io.Flush;
      Mandel_Control_Package.Initialise_Queue;
      Text_Io.Put_Line( "Hello 2" ); Text_Io.Flush;

      for Count in Integer range 1..Number_Of_Tasks loop
         Text_Io.Put_Line( Integer'Image( Integer( Count ) ) ); Text_Io.Flush;
         Task_Array( Count ).Startup( Id => Count );
      end loop;
--      Mandel_Task_1.Startup( Id => 1, Queue => Queue_1 );
--      Mandel_Task_2.Startup( Id => 2, Queue => Queue_2 );
--      Mandel_Task_3.Startup( Id => 3 );
--      Mandel_Task_4.Startup( Id => 4 );
--      Mandel_Task_5.Startup( Id => 5 );
--      Mandel_Task_6.Startup( Id => 6 );
--      Mandel_Task_7.Startup( Id => 7 );
--      Mandel_Task_8.Startup( Id => 8 );
--      Mandel_Task_9.Startup( Id => 9 );
--      Mandel_Task_10.Startup( Id => 10 );
--      Mandel_Task_11.Startup( Id => 11 );
--      Mandel_Task_12.Startup( Id => 12 );
--      Mandel_Task_13.Startup( Id => 13 );
--      Mandel_Task_14.Startup( Id => 14 );
--      Mandel_Task_15.Startup( Id => 15 );
--      Mandel_Task_16.Startup( Id => 16 );


      Display_Task( W => W );

      Text_Io.Put_Line( "System claims to have finished!" );
      Text_Io.Flush;


      for Count in Integer range 1..Number_Of_Tasks loop
        abort Task_Array( Count );
      end loop;--      abort Mandel_Task_1;
--      abort Mandel_Task_2;
--      abort Mandel_Task_3;
--      abort Mandel_Task_4;
--      abort Mandel_Task_5;
--      abort Mandel_Task_6;        Text_Io.Put_Line( Exception_Message( E )); Text_Io.Flush;

--      abort Mandel_Task_7;
--      abort Mandel_Task_8;
--      abort Mandel_Task_9;
--      abort Mandel_Task_10;
--      abort Mandel_Task_11;
--      abort Mandel_Task_12;
--      abort Mandel_Task_13;
--      abort Mandel_Task_14;
--      abort Mandel_Task_15;
--      abort Mandel_Task_16;

  exception
     when E : others =>
        Text_Io.Put_Line( "Mandel_Control: exception Raised" );
        Text_Io.Put_Line( Exception_Name( E )); Text_Io.Flush;
        Text_Io.Put_Line( Exception_Message( E )); Text_Io.Flush;
        Text_Io.Put_Line( Exception_Information( E )); Text_Io.Flush;
        Reraise_Occurrence( E );
  end Generate_Plot;


end Mandel_Control_Package;
