with Text_Io;

with Output_Area_Type_Package;
use  Output_Area_Type_Package;

with Area_Queue_Package;
use  Area_Queue_Package;

with Output_Queues;
use  Output_Queues;

package body Output_Queue_Package is

   AQueue : Queue_Type_Access := new Queue_Type;

   protected body Output_Queue is
    
      function Stopped return Boolean is
      begin
         return ( ( ( Length( Aqueue ) = 0 ) and
                      ( Put'Count = 0 ) and
                      ( Get'Count = 1 ) ) );
      end Stopped;

      entry Put( Area  : in Output_Area_Type ) when True is
      begin
         Put( Item  => Area,
              Queue => AQueue );
      end Put;

      entry Append( Queue : in out Queue_Type_Access ) when True is
      begin
         Append( Source_Queue => Queue,
                 Destination_Queue => AQueue );
      end Append;

      entry Get( Area : out Output_Area_Type;
                 Done : out Boolean ) when ( Length( AQueue ) > 0 ) is
         Area_Queue_Done : Boolean := False;
      begin

         Area := Get( Queue => AQueue );

         if ( Length( AQueue ) = 0 ) and then
            ( Append'Count = 0 ) and then
            ( Put'Count = 0 ) then
            Area_Queue.Done( Area_Queue_Done );
         end if;
         Done := Area_Queue_Done;

      end Get;

      entry Toggle_Queues( Queue : access Queue_Type;
                           Done  : out Boolean ) when ( ( Length( AQueue ) > 1000 ) 
                                             or else  ( ( Append'Count = 0 )
                                               and then ( Put'Count    = 0 ) ) ) is
         Area_Queue_Done : Boolean := False;
      begin

--         Text_Io.Put_Line( "Output Toggle" );  Text_Io.Flush;
         Swap( Queue, AQueue );

         if ( Append'Count = 0 ) and then
            ( Put'Count = 0 ) then
            Area_Queue.Done( Area_Queue_Done );
         end if;
         Done := Area_Queue_Done;

      end Toggle_Queues;

   end Output_Queue;
end Output_Queue_Package;



