-- Simple use of Motif
-- Chris Morgan 2/9/95
with Interfaces.C;
with Stdarg;
with Text_IO;
with X.Args;
with X.Strings;
with X.Xlib;
with Xt.Intrinsic;
with Xt.Composite;
with Motif.Xm;
with Motif.Pushb;
with Motif.xmstrdefs;
with Motif.DrawingA;
with Motif.Form;
with Motif.Label;
with Callbacks_Package;
use Callbacks_Package;

with Constants;
use  Constants;

procedure Simple_Motif_Prog is

   pragma Priority( 10 );

   label : Motif.Xm.XmString;

   Screen_X : Interfaces.C.Unsigned := Interfaces.C.Unsigned( Screen_Size_X + 55 );
   Screen_Y : Interfaces.C.Unsigned := Interfaces.C.Unsigned( Screen_Size_Y + 55 );
--   Screen_X : Long_Integer := Screen_Size_X + 55;
--   Screen_Y : Long_Integer := Screen_Size_Y + 55;
   Draw_X   : Interfaces.C.Unsigned := Interfaces.C.Unsigned( Screen_Size_X );
   Draw_Y   : Interfaces.C.Unsigned := Interfaces.C.Unsigned( Screen_Size_Y );

begin
   My_Window := 
     Xt.Intrinsic.
     XtvaAppInitialize(App_Context_Return => App'access,
		       Application_Class  => "X", 
		       Options            => null,
		       Num_Options        => 0,
		       Argc_In_Out        => X.Args.Argc'access,
		       Argv_In_Out        => X.Args.Argv,
		       Fallback_Resources => null,
--		       Args               => Stdarg.Empty & Nulst);, 
		       Args               => Stdarg.Empty & 
		       Motif.Xmstrdefs.XmNwidth  & Xt.Intrinsic.dimension( Screen_X ) & 
		       Motif.Xmstrdefs.XmNheight & Xt.Intrinsic.dimension( Screen_Y ) & Nulst);
   Form := Xt.Intrinsic.
     Xtvacreatewidget (Name   => "form",
		       Widget_class => Motif.form.Xmformwidgetclass_Obj,
		       Parent => My_Window);

    -- Button1
    Label := Motif.Xm.XmStringCreateSimple("Again");

    Button1 := Xt.Intrinsic.XtVaCreateManagedWidget(
	"redraw", Motif.Pushb.xmPushButtonWidgetClass_obj, Form , 
	Stdarg.Empty & Motif.xmstrdefs.XmNlabelString & label & 
		       Motif.Xmstrdefs.Xmntopattachment & 
		       Motif.Xm.Xmattach_Form &
		       Motif.Xmstrdefs.Xmntopoffset & 2 &
		       Motif.Xmstrdefs.Xmnleftattachment & 
		       Motif.Xm.Xmattach_Form & 
		       Motif.Xmstrdefs.Xmnleftoffset & 2 &
						    Nulst);

    Xt.Intrinsic.XtAddCallback(
	Button1, Motif.xmstrdefs.XmNactivateCallback,
	Callbacks_Package.Redraw'access, null);
    Motif.Xm.XmStringFree(label);

    -- Button2
    Label := Motif.Xm.XmStringCreateSimple("Reset");

    Button2 := 
      Xt.Intrinsic.
      XtVaCreateManagedWidget("Reset", 
			      Motif.Pushb.xmPushButtonWidgetClass_obj, 
			      Form , 
			      Stdarg.Empty & 
			      Motif.xmstrdefs.XmNlabelString & label & 
			      Motif.Xmstrdefs.Xmntopattachment & 
			      Motif.Xm.Xmattach_Widget &
			      Motif.Xmstrdefs.Xmntopwidget & Button1 & 
			      Motif.Xmstrdefs.Xmntopoffset & 2 &
			      Motif.Xmstrdefs.Xmnleftattachment & 
			      Motif.Xm.Xmattach_Form & 
			      Motif.Xmstrdefs.Xmnleftoffset & 2 &
			      Nulst);

    Xt.Intrinsic.XtAddCallback(
	Button2, Motif.xmstrdefs.XmNactivateCallback,
	Callbacks_Package.Reset'access, null);

     Motif.Xm.XmStringFree(label);

    -- Button3
    Label := Motif.Xm.XmStringCreateSimple("Exit ");
    Button3 := 
      Xt.Intrinsic.XtVaCreateManagedWidget("goaway", 
					   Motif.Pushb.xmPushButtonWidgetClass_obj, 
					   Form, 
					   Stdarg.Empty & 
					   Motif.xmstrdefs.XmNlabelString & label & 
					   Motif.Xmstrdefs.Xmntopattachment & 
					   Motif.Xm.Xmattach_Widget &
					   Motif.Xmstrdefs.Xmntopwidget & Button2 & 
					   Motif.Xmstrdefs.Xmntopoffset & 2 &
					   Motif.Xmstrdefs.Xmnleftattachment & 
					   Motif.Xm.Xmattach_Form & 
					   Motif.Xmstrdefs.Xmnleftoffset & 2 &
					   Nulst);
    Xt.Intrinsic.XtAddCallback(
	Button3, Motif.xmstrdefs.XmNactivateCallback,
	Callbacks_Package.Go_Away'access, null);
    Motif.Xm.XmStringFree(label);

   Drawing_Area := 
      Xt.Intrinsic.
     XtVaCreatemanagedWidget(Name   => "drawingArea",
			     Widget_Class => 
			       Motif.Drawinga.Xmdrawingareawidgetclass_Obj,
			     Parent => Form , 
			     Args => Stdarg.Empty & 
			     Motif.Xmstrdefs.Xmnwidth & Xt.Intrinsic.Dimension( Draw_X ) &
			     Motif.Xmstrdefs.Xmnheight & Xt.Intrinsic.Dimension( Draw_Y ) &
			     Motif.Xmstrdefs.Xmnrightattachment & 
			     Motif.Xm.Xmattach_Form & 
			     Motif.Xmstrdefs.Xmnrightoffset & 10 &
			     Motif.Xmstrdefs.Xmntopattachment & 
			     Motif.Xm.Xmattach_Form &
			     Motif.Xmstrdefs.Xmntopoffset & 10 &
			     Nulst);
   
    Xt.Intrinsic.
      Xtaddcallback(Widget        => Drawing_Area,
		    Callback_Name => Motif.Xmstrdefs.XmNexposeCallback,
		    Callback      => Callbacks_Package.Exposurecb'access,
		    Closure       => null);
    Xt.Intrinsic.
      Xtaddcallback(Widget        => Drawing_Area,
		    Callback_Name => Motif.Xmstrdefs.XmNresizeCallback,
		    Callback      => Callbacks_Package.Resizecb'access,
		    Closure       => null);
    Xt.Intrinsic.
      Xtaddcallback(Widget        => Drawing_Area,
		    Callback_Name => Motif.Xmstrdefs.XmNinputCallback,
		    Callback      => Callbacks_Package.Inputcb'access,
		    Closure       => null);

    -- Graphics context for drawing using xlib
    The_Gc := 
      X.Xlib.Xcreategc(Display   => Xt.Intrinsic.XtDisplay(Drawing_Area),
		       D         => X.Drawable(X.Xlib.Xrootwindowofscreen
			            (Xt.Intrinsic.XtScreen(Drawing_Area))),
		       Valuemask => Valuemask,
		       Values    => Values'access);

    -- Plain label

    Label := Motif.Xm.XmStringCreateSimple("Ada95 Rules!!!!");

    Label_Widget :=
      Xt.Intrinsic.
      XtVaCreatemanagedWidget(Name   => "drawingArea",
			      Widget_Class => 
				Motif.Label.XmLabelwidgetclass_Obj,
			      Parent => Form , 
			      Args => Stdarg.Empty & 
			      Motif.xmstrdefs.XmNlabelString & label & 
			      Motif.Xmstrdefs.Xmnwidth & 150 &
			      Motif.Xmstrdefs.Xmnheight & 30 &
			      Motif.Xmstrdefs.Xmnbottomattachment & 
			      Motif.Xm.Xmattach_Form &
			      Motif.Xmstrdefs.Xmnbottomoffset & 2 &
			      Motif.Xmstrdefs.Xmnleftattachment & 
			      Motif.Xm.Xmattach_Form & 
			      Motif.Xmstrdefs.Xmnleftoffset & 25 &
			      Nulst);
    Motif.Xm.XmStringFree(label);

    -- Standard Motif style main program.
    Xt.Composite.XtManageChild(Form);
    Xt.Intrinsic.XtRealizeWidget(My_Window);
    Xt.Intrinsic.XtAppMainLoop(App);
end;
